BFTT - EDITORIAL

PROBLEM LINK:

Practice
Contest: Division 2

Setter: Aleksa Plavsic
Tester: Hussain
Editorialist: Taranpreet Singh

DIFFICULTY:

Cakewalk

PREREQUISITES:

Brute Force

PROBLEM:

Given an integer N, find smallest number X > N such that X contains digit 3 at least 3 times.

SUPER QUICK EXPLANATION

  •   Check for next 1000 numbers, print the smallest one which contains digit 3 at least 3 times.
    

EXPLANATION

Let us call a number valid if it contains digit 3 at least 3 times, else invalid.

Let us begin with most basic Solution which runs a loop from N+1 to Infinity, and breaks the loop as soon as a valid number is found. But we may expect this solution to time out, right??.

Now, Brace yourselves for the next line.

This solution runs easily within time limit.

Now you will ask me to prove how, so here it goes.

Consider a set of 1000 elements consisting of X \in [N+1, N+1000]. Now, observe two things.

  • The last 3 digits of each number in set differ, since consecutive numbers differ by 1 each
  • There will exist a number ending with 333 in set. This number will always be valid since it contains digit 3 at least 3 times, So we don’t need to search beyond this number.

Hence, it can be proved that checking for next 1000 values will always find the required answer. Worst case would be realized on case such as 333, as the smallest valid number after 333 is 1333.

If you want a formal proof, it can also be proved using modulo finite fields.

Counting number of occurrences of digit 3 in N.

Click to view

int cnt = 0; while(n != 0){ if(n%10==3)cnt++; n/=10; }

Complexity:
Since we check 1000 values per test case, and counting Number of occurrences of digit 3 takes \log_{10} N time, Time Complexity is O(1000*T*{\log_{10} N}).

Bonus Problems

Find X>N such that X contains digit a atleast b times. What would be time complexity? Can you improve it?

A General Technique

Though this problem can be solved using brute force, There’s a different technique which can also solve this problem, Called Digit DP. An interesting similar problem of Digit DP can be found here.

AUTHOR’S AND TESTER’S SOLUTIONS:

Setter’s solution
Tester’s solution
Editorialist’s solution

Feel free to Share your approach, If it differs. Suggestions are always welcomed. :slight_smile:

Video solution (in C++, Java, Python and BASH): https://youtu.be/Enbht_Uf1CE

2 Likes

//what is wrong in this code?

#include
#include
using namespace std;
int main()
{

int t;
cin>>t;
for(int p=0;p<t;p++)
{  int i;
	long long int n;
	cin>>n;
	long long int a[18];
	int j=n;int k=0;int count=0;
	while(j)
	{
		a[k]=j%10;
		if(a[k]==3)
		{
		count++;}
		j=j/10;
		k++;
		
		
	}//cout<<"k"<<k<<endl;
//	cout<<count<<endl;
		
	//	for(i=k-1;i>=0;i--)
	//	cout<<a[i]<<endl;
	//	cout<<"a"<<endl;
	if(n>=333)
	{
	
	if(count>=3 &&  k>count)
	{ int i=0;
//	cout<<"here"<<endl;
	while(a[i]==3)
	{
		i++;
		
		
	}//cout<<"i"<<i<<endl;
		a[i]=a[i]+1;
		for(i=k-1;i>=0;i--)
		cout<<a[i];
		cout<<endl;
	}
	else if(k<=count&&count>=3)
	cout<<"1"<<n<<endl;
	
	else if(count<3 && k>3)
	{//cout<<"here";
		int c=3-count;
		i=0;
		while(c )
		{    if(a[i]!=3)
			{
			a[i]=3;c--;}
			i++;
		}
		
		
		
		
		for(i=k-1;i>=0;i--)
		cout<<a[i];
		cout<<endl;
	}
	else if(count<3 && k<=3)
	{//cout<<"here";
		int c=3-count;
		i=0;
		while(c )
		{    if(a[i]!=3)
			{
			a[i]=3;c--;}
			i++;
		}
		
		
		
		cout<<"1";
		for(i=k-1;i>=0;i--)
		cout<<a[i];
		cout<<endl;
	}
	
}
else
cout<<"333"<<endl;}}

@admin Can you please disable the MOSS for such cakewalk problems. I had to face the (infamous ?) points penalty just because some other random dude happened to have used the exact same code structure. Please, this is so frustrating. The solutions in question are -

https://www.codechef.com/viewsolution/19786629

https://www.codechef.com/viewsolution/19801288

for i in range(int(input())):
n=int(input())
for j in range(n+1,2*1000000000):
if(str(j).count(‘3’)==3):
print(j)
break
#why this code is not correct?